#pragma once

#include <string>
#include <map>
#include <vector>
#include <memory>
#include <iostream>

#include "vmm_params.h"

class VMM3a {
public:
  VMM3a();
  ~VMM3a();

  void LoadDefault();

  struct VMM3aSettings{
    std::map<std::string, unsigned short> channels[CHANNELS_PER_VMM];
    std::map<std::string, unsigned short> globalRegisters;
  };

  const VMM3aSettings& getVMM3aSettings() const;
  vmmStatus setRegister(std::string feature, int val);
  vmmStatus setRegister(std::string feature, int val, int ch);
  vmmStatus getRegister(std::string feature, unsigned short& result) const;
  vmmStatus getRegister(std::string feature, int ch, unsigned short& result) const;
  vmmStatus getInfo(const std::string& feature, std::string& result);
  vmmStatus setInfo(const std::string& feature, const std::string& value);

private:
  vmmStatus updateRegisterMap(std::string feature, int value);
  vmmStatus updateRegisterMap(std::string feature, int value, int ch);
  std::unique_ptr<VMM3aSettings> vmm3aSettings;
  std::map<std::string, std::string> vmmInfo = {{"all_sc", "0"}, {"all_sl", "0"}, {"all_st", "0"}, {"all_sth", "0"},{"all_sm", "0"}, {"all_sd", "0"},{"all_smx", "0"},
                                                    {"all_sz10b", "0"},{"all_sz08b", "0"}, {"all_sz06b", "0"},{"adc_value", ""}, {"description",""}};
};