#pragma once

#include "rmm.h"
#include "FrontEndBase.h"
#include "vmm_tbl_regs_map.h"
#include "vmm_config.h"

/** Class definition for the VMMTbl class */
class VMMTbl : public FrontEndBase {
public:
  VMMTbl(RMM& rmm, int ring, int node);
  asynStatus create_epics_params();
	virtual asynStatus writeInt32(asynUser *pasynUser, epicsInt32 value);
  virtual asynStatus writeFloat64(asynUser *pasynUser, epicsFloat64 value);
  void set_initial_epics_params();
  void config_FE();

protected:
  int vmmSelectMonitorVMM0_;
  int vmmSelectMonitorVMM1_;
  int vmmProcessReadMonitorVMMs_;
  int vmmMonitorValueVMM0_;
  int vmmMonitorValueVMM1_;

private:
  FENConfigModule pVMMConfig;
  RMM *pRMM;
  int addr_list = 0;
};
